//-------------------------------------------------------------------------------------------------+
// AislGlobalPlanningSVC_impl.cpp
// Service implementation code of AislGlobalPlanning.idl
//-------------------------------------------------------------------------------------------------+

#include "AislGlobalPlanningSVC_impl.h"


//-------------------------------------------------------------------------------------------------+
// RXgN^
//-------------------------------------------------------------------------------------------------+
AreaInfoServiceSVC_impl::AreaInfoServiceSVC_impl( TUT::TimedAreaInfo *areainfo, CRITICAL_SECTION *cs ){

	this->areainfo = areainfo;
	c_section      = cs;
}


//-------------------------------------------------------------------------------------------------+
// fXgN^
//-------------------------------------------------------------------------------------------------+
AreaInfoServiceSVC_impl::~AreaInfoServiceSVC_impl(){
}


//-------------------------------------------------------------------------------------------------+
// TuGAԂ
//-------------------------------------------------------------------------------------------------+
TUT::TimedAreaInfo *AreaInfoServiceSVC_impl::getAreaInfo(){

	EnterCriticalSection( c_section );

	TUT::TimedAreaInfo *area_info = new TUT::TimedAreaInfo();

	area_info->tm = areainfo->tm;

	area_info->data.length( areainfo->data.length() );

	for( int i=0; i<(int)areainfo->data.length(); i++ ){

		area_info->data[i].id         = areainfo->data[i].id;
		area_info->data[i].population = areainfo->data[i].population;

		area_info->data[i].vertexes.length( areainfo->data[i].vertexes.length() );

		for( int j=0; j<(int)areainfo->data[i].vertexes.length(); j++ ){

			area_info->data[i].vertexes[j].x = areainfo->data[i].vertexes[j].x;
			area_info->data[i].vertexes[j].y = areainfo->data[i].vertexes[j].y;
		}

		area_info->data[i].links.length( areainfo->data[i].links.length() );

		for( int j=0; j<(int)areainfo->data[i].links.length(); j++ ){

			area_info->data[i].links[j].id = areainfo->data[i].links[j].id;

			area_info->data[i].links[j].boder.p1.x = areainfo->data[i].links[j].boder.p1.x;
			area_info->data[i].links[j].boder.p1.y = areainfo->data[i].links[j].boder.p1.y;
			area_info->data[i].links[j].boder.p2.x = areainfo->data[i].links[j].boder.p2.x;
			area_info->data[i].links[j].boder.p2.y = areainfo->data[i].links[j].boder.p2.y;
		}
	}

	LeaveCriticalSection( c_section );

	return area_info;
}

