//-------------------------------------------------------------------------------------------------+
// GlobalMapFileStream.cpp
// n}ۑǂݏo肷NX̊֐`
//-------------------------------------------------------------------------------------------------+

#include "GlobalMapFileStream.h"

/*
//-------------------------------------------------------------------------------------------------+
// RXgN^
//-------------------------------------------------------------------------------------------------+
GlobalMapFileOutStream::GlobalMapFileOutStream( const char *filename ){

	open = false;
	Open( filename );
}


//-------------------------------------------------------------------------------------------------+
// t@Cɕۑ
//-------------------------------------------------------------------------------------------------+
bool GlobalMapFileOutStream::Write( MRFC::TimedFloatAbsoluteOGMapData *mapdata, SubAreas *subarea ){

	return ( Write( mapdata ) && Write( subarea ) );
}


//-------------------------------------------------------------------------------------------------+
// t@CJ
//-------------------------------------------------------------------------------------------------+
void GlobalMapFileOutStream::Open( const char *filename ){

	if( open ) return;

	fout.open( filename );

	if( fout ){
		open = true;
		cerr << "File " << filename << " is opened.\n";
	}
	else{
		open = false;
		cerr << "File " << filename << " could not be opened.\n";
	}
}


//-------------------------------------------------------------------------------------------------+
// t@Cɑn}f[^ۑ
//-------------------------------------------------------------------------------------------------+
bool GlobalMapFileOutStream::Write( MRFC::TimedFloatAbsoluteOGMapData *mapdata ){

	if( !mapdata ) return false;
	
	fout << mapdata->mapconfig.width  << " ";
	fout << mapdata->mapconfig.height << " ";
	fout << mapdata->mapconfig.xScale << " ";
	fout << mapdata->mapconfig.yScale << " ";

	fout << mapdata->mapconfig.origin.position.x << " ";
	fout << mapdata->mapconfig.origin.position.y << " ";

	fout << mapdata->cells.length() << endl;

	for( int i=0; i< mapdata->cells.length(); i++ ) fout << mapdata->cells[i] << " ";

	fout << endl;

	return true;
}


//-------------------------------------------------------------------------------------------------+
// t@CɃGAۑ
//-------------------------------------------------------------------------------------------------+
bool GlobalMapFileOutStream::Write( SubAreas *subarea ){

	if( !subarea ) return false;

	fout << subarea->size() << endl;

	for( int i=0; i<(int)subarea->size(); i++ ){

		fout << (*subarea)[i].ID() << "  ";
		fout << (*subarea)[i].population << endl;

		Vertexes vertexes = (*subarea)[i].Vertex();

		fout << vertexes.size() << " ";

		for( int j=0; j<(int)vertexes.size(); j++ ){

			fout << vertexes[j].x << " ";
			fout << vertexes[j].y << " ";
		}

		vector<int> ids = (*subarea)[i].ConnectedAreaIDs();

		fout << ids.size() << " ";

		for( int j=0; j<(int)ids.size(); j++ ){

			fout << ids[j] << " ";

			Segment seg = (*subarea)[i].Border( ids[j] );

			fout << seg.x << " ";
			fout << seg.y << " ";
			fout << seg.x + seg.dx << " ";
			fout << seg.y + seg.dy << " ";
		}

		fout << endl;
	}

	return true;
}
*/


//**************************************************************************************************


//-------------------------------------------------------------------------------------------------+
// RXgN^
//-------------------------------------------------------------------------------------------------+
GlobalMapFileInStream::GlobalMapFileInStream( const char *filename ){

	read = false;
	OpenAndRead( filename );
}


//-------------------------------------------------------------------------------------------------+
// t@CJăf[^ǂ݂
//-------------------------------------------------------------------------------------------------+
void GlobalMapFileInStream::OpenAndRead( const char *filename ){

	if( read ) return;

	fin.open( filename );

	if( !fin ){

		cerr << "File " << filename << " could not be opened.\n";
		return;
	}

	cerr << "File " << filename << " is opened.\n";

	if( ReadMapData() && ReadAreaInfo() ) read = true;

	fin.close();
}


//-------------------------------------------------------------------------------------------------+
// t@Cn}f[^ǂݍ
//-------------------------------------------------------------------------------------------------+
bool GlobalMapFileInStream::ReadMapData(){
	
	fin >> mapdata.mapconfig.width;
	fin >> mapdata.mapconfig.height;
	fin >> mapdata.mapconfig.xScale;
	fin >> mapdata.mapconfig.yScale;

	fin >> mapdata.mapconfig.origin.position.x;
	fin >> mapdata.mapconfig.origin.position.y;

	mapdata_f.mapconfig = mapdata.mapconfig;

	long length;
	fin >> length;
	mapdata.cells.length( length );
	mapdata_f.cells.length( length );

	for( int i=0; i< length; i++ ){
		
		fin >> mapdata_f.cells[i];

		if( mapdata_f.cells[i] < 0.0 || 1.0 < mapdata_f.cells[i] ) mapdata.cells[i] = -1;
		else mapdata.cells[i] = (unsigned char)( 100.0 * mapdata_f.cells[i] );
	}

	return true;
}


//-------------------------------------------------------------------------------------------------+
// t@CGAǂݍ
//-------------------------------------------------------------------------------------------------+
bool GlobalMapFileInStream::ReadAreaInfo(){

	long length;
	fin >> length;
	areainfo.data.length( length );

	for( int i=0; i<(int)length; i++ ){

		fin >> areainfo.data[i].id;
		fin >> areainfo.data[i].population;

		long vertexes_num;
		fin >> vertexes_num;
		areainfo.data[i].vertexes.length( vertexes_num );

		for( int j=0; j<(int)vertexes_num; j++ ){

			fin >> areainfo.data[i].vertexes[j].x;
			fin >> areainfo.data[i].vertexes[j].y;
		}

		long link_num;
		fin >> link_num;
		areainfo.data[i].links.length( link_num );

		for( int j=0; j<(int)link_num; j++ ){

			fin >> areainfo.data[i].links[j].id;

			fin >> areainfo.data[i].links[j].boder.p1.x;
			fin >> areainfo.data[i].links[j].boder.p1.y;
			fin >> areainfo.data[i].links[j].boder.p2.x;
			fin >> areainfo.data[i].links[j].boder.p2.y;
		}
	}

	return true;
}

