//-------------------------------------------------------------------------------------------------+
// GlobalMapManager.h
// n}ǗRTC
//-------------------------------------------------------------------------------------------------+

#ifndef GLOBALMAPMANAGER_H
#define GLOBALMAPMANAGER_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include <rtm/idl/InterfaceDataTypesSkel.h>

// Service implementation headers
#include "MRFCSVC_impl.h"
#include "AislGlobalPlanningSVC_impl.h"

#include "Simulator/Network.h"

using namespace RTC;


//-------------------------------------------------------------------------------------------------+
// n}ǗRTC̃CNX
//-------------------------------------------------------------------------------------------------+
class GlobalMapManager : public RTC::DataFlowComponentBase{

public:
	GlobalMapManager(RTC::Manager* manager);
	~GlobalMapManager();

	virtual RTC::ReturnCode_t onInitialize();
	virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);
	virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);
	virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

protected:
	std::string m_filename;

	TUT::TimedPersonsGlobalPosition m_persons;
	InPort<TUT::TimedPersonsGlobalPosition> m_personsIn;

	// CORBA Port declaration
	RTC::CorbaPort m_AbsoluteMapServicePort;
	RTC::CorbaPort m_AreaInfoServicePort;

	// Service declaration
	AbsoluteMapServiceSVC_impl m_AbsoluteMapService;
	AreaInfoServiceSVC_impl m_AreaInfoService;

private:
	CRITICAL_SECTION cs_mapdata, cs_areainfo;
	MRFC::TimedAbsoluteOGMapData mapdata;
	TUT::TimedAreaInfo areainfo;
	SubAreas subareas;

	SubAreas ConvertSubAreas( TUT::TimedAreaInfo *areainfo );
	void ResetPopulation();
	void SetPopulation();
	void CalcPopulation();
};



//-------------------------------------------------------------------------------------------------+
extern "C"
{
  DLL_EXPORT void GlobalMapManagerInit(RTC::Manager* manager);
};

#endif // GLOBALMAPMANAGER_H
