//------------------------------------------------------------------------------------------------+
// Filename: Network.h
// Content : ړlbg[N֘ANX̊֐`
//------------------------------------------------------------------------------------------------+

#include "Network.h"
#include <cmath>


//------------------------------------------------------------------------------------------------+
// }N̒`
//------------------------------------------------------------------------------------------------+
#define FRUIN_CONST_A		1.356		// Qlɂ萔
#define FRUIN_CONST_B		0.341		// Qlɂ萔
#define HEUR_DIV			2.0			// q[XeBbN̐Ŋ


/*************************************** TuGANX ****************************************/

// Name: CheckConnect() --------------------------------------------------------------------------+
// w肵TuGAƐڂĂtrueԂ
//------------------------------------------------------------------------------------------------+
bool SubArea::CheckConnect( int id ){

	for( int i=0; i< (int)links.size(); i++ ) if( links[i].id == id ) return true;
	return false;
}


// Name: CheckConnect() --------------------------------------------------------------------------+
// w肵TuGAƐڂĂtrueԂ
//------------------------------------------------------------------------------------------------+
bool SubArea::CheckConnect( SubArea area ){

	return CheckConnect( area.ID() );
}


// Name: Border() --------------------------------------------------------------------------------+
// w肵TuGAƐڂĂ΂̋EԂ
//------------------------------------------------------------------------------------------------+
Line SubArea::Border( int area_id ){

	for( int i=0; i< (int)links.size(); i++ ) if( links[i].id == area_id ) return links[i].boder;
	return Line();
}


// Name: Border() --------------------------------------------------------------------------------+
// w肵TuGAƐڂĂ΂̋EԂ
//------------------------------------------------------------------------------------------------+
Line SubArea::Border( SubArea area ){

	return Border( area.ID() );
}


// Name: Distance() ------------------------------------------------------------------------------+
// w肵QTuGAƐڂĂ΂̊ԊuԂ
// ڂĂȂ0Ԃ
//------------------------------------------------------------------------------------------------+
double SubArea::Distance( int id1, int id2 ){

	int no1, no2;		// N̓Y
	no1 = no2 = -1;

	for( int i=0; i< (int)links.size(); i++ ){

		if( links[i].id == id1 ) no1 = i;
		if( links[i].id == id2 ) no2 = i;
	}

	if( no1 == -1 || no2 == -1 ) return 0.0;		// ȂĂȂ

	Line v;

	v.x  = links[no1].boder.CenterX();
	v.y  = links[no1].boder.CenterY();
	v.dx = links[no2].boder.CenterX() - v.x;
	v.dy = links[no2].boder.CenterY() - v.y;

	return v.Length();
}


// Name: Distance() ------------------------------------------------------------------------------+
// w肵QTuGAƐڂĂ΂̊ԊuԂ
// ڂĂȂ0Ԃ
//------------------------------------------------------------------------------------------------+
double SubArea::Distance(  SubArea area1,  SubArea area2 ){

	return Distance( area1.ID(), area2.ID() );
}


//------------------------------------------------------------------------------------------------+
// ڂĂGAIDnԂ
//------------------------------------------------------------------------------------------------+
vector<int> SubArea::ConnectedAreaIDs(){

	vector<int> ids;

	for( int i=0; i<(int)links.size(); i++ ) ids.push_back( links[i].id );

	return ids;
}



/************************************** lbg[NNX ***************************************/

// Name: PathFinding() ---------------------------------------------------------------------------+
// startgoalւ̌oHvZ
//------------------------------------------------------------------------------------------------+
PathCost Network::PathFinding( Coordinate start, Coordinate goal ){

	// startgoalTuGÂƂ͌oHȂ
	if( SubAreaNo( start ) == SubAreaNo( goal ) ) return PathCost();

	Data data = InitList( start, goal );

	while( !data.sorted_open.empty() ){

		// I[vXg̍łXRAȃm[h𓾂
		int search = data.MinScore();

		//oH̊
		if( search == data.goal ){

			// S[n_܂ł̃RXgvZ
			data.lst[search].cost += Line( subareas[search].Border( subareas[data.lst[search].next].ID() ).Center(), goal ).Length();
			return GeneratePath( data );
		}

		// ݂̃m[hɗאڂem[h𒲂ׂ
		else for( int i=0; i< (int)subareas.size(); i++ ) if( search != i ){

			// אڂĂāAI[vXgɂN[YXgɂ
			if( subareas[search].CheckConnect(subareas[i].ID()) && !data.lst[i].open && !data.lst[i].close ){

				double walking_rate = FRUIN_CONST_A - FRUIN_CONST_B * subareas[search].Density();

				if( walking_rate <= 0.0 ) continue;		// GĒʂȂii߂Ȃj

				// RXgvZăI[vXgɈڂ
				data.lst[i].cost = data.lst[search].cost + subareas[search].Distance( subareas[i].ID(), subareas[data.lst[search].next].ID() ) / walking_rate;
				data.lst[i].heur = Abs( subareas[search].Border(subareas[i].ID()).CenterX() - goal.x ) + Abs( subareas[search].Border(subareas[i].ID()).CenterY() - goal.y );
				data.lst[i].next = search;
				data.AddOpen(i);
			}
		}
	}

	return PathCost();
}


// Name: InitList() ------------------------------------------------------------------------------+
// Xg𐶐
//------------------------------------------------------------------------------------------------+
Network::Data Network::InitList( Coordinate start, Coordinate goal ){

	int start_no = SubAreaNo( start );

	Data data( (int)subareas.size(), start_no, SubAreaNo( goal ) );

	for( int i=0; i< (int)subareas.size() ;i++ ) if( i != start_no ){

		// JnTuGAɐڑTuGAI[vXgɒǉ
		if( subareas[i].CheckConnect( subareas[start_no].ID() )){

			double walking_rate = FRUIN_CONST_A - FRUIN_CONST_B * subareas[start_no].Density();

			if( walking_rate <= 0.0 ) continue;		// GĒʂȂii߂Ȃj

			data.lst[i].cost = Line( start, subareas[i].Border(subareas[start_no].ID()).Center() ).Length() / walking_rate;
			data.lst[i].heur = Abs( start.x - goal.x ) + Abs( start.y - goal.y );
			data.lst[i].next = start_no;
			data.AddOpen( i );
		}
	}

	data.lst[start_no].close = true;

	return data;
}


// Name: GeneratePath() --------------------------------------------------------------------------+
// XgoH𐶐
//------------------------------------------------------------------------------------------------+
PathCost Network::GeneratePath( Data data ){

	PathCost path;

	path.cost = data.lst[data.goal].cost;

	while( data.goal != data.start ){

		path.path.push_front( subareas[data.goal] );
		data.goal = data.lst[data.goal].next;
	}
	path.path.push_front( subareas[data.start] );

	return path;
}


// Name: SubAreaNo() -----------------------------------------------------------------------------+
// WTuGAz̓YԂ
// ǂɂȂ-1Ԃ
//------------------------------------------------------------------------------------------------+
int Network::SubAreaNo( Coordinate pos ){

	for( int i=0; i< (int)subareas.size(); i++ ) if( subareas[i].InSide( pos )) return i;
	return -1;
}


// Name: SubAreaID() -----------------------------------------------------------------------------+
// WTuGAIDԂ
// ǂɂȂ-1Ԃ
//------------------------------------------------------------------------------------------------+
int Network::SubAreaID( Coordinate pos ){

	for( int i=0; i< (int)subareas.size() ;i++ ) if( subareas[i].InSide( pos )) return subareas[i].ID();
	return -1;
}


// Name: GetSubArea() ----------------------------------------------------------------------------+
// WTuGAԂ
//------------------------------------------------------------------------------------------------+
SubArea Network::GetSubArea( Coordinate pos ){

	for( int i=0; i< (int)subareas.size() ;i++ ) if( subareas[i].InSide( pos )) return subareas[i];
	throw "Error: Coordinate is out of subareas.";
}


// Name: AddPopulation() -------------------------------------------------------------------------+
// wW̃TuGA̐lZ
//------------------------------------------------------------------------------------------------+
void Network::AddPopulation( Coordinate c ){

	int id = SubAreaNo(c);
	if( 0 <= id && id < (int)subareas.size() ) subareas[id].population++;
}


// Name: ResetPopulation() -----------------------------------------------------------------------+
// STuGA̐lOɂ
//------------------------------------------------------------------------------------------------+
void Network::ResetPopulation(){

	for( int i=0; i< (int)subareas.size(); i++ ) subareas[i].population = 0;
}



/*********************************** oHTp̃f[^NX ************************************/

// Name: Data() ----------------------------------------------------------------------------------+
// RXgN^
//------------------------------------------------------------------------------------------------+
Network::Data::Data( int size, int start_no, int goal_no ){

	start = start_no;
	goal  = goal_no;
	lst.resize( size );
}


// Name: MinScore() ------------------------------------------------------------------------------+
// I[vXgŏXRÃm[h̓YԂ
//------------------------------------------------------------------------------------------------+
int Network::Data::MinScore(){
 
	int no;

	if( !sorted_open.empty() ){

		no = sorted_open.front();

		// m[hN[YXgɈڂ
		lst[no].open  = false;
		lst[no].close = true;
		sorted_open.pop_front();
	}

	return no;
}


// Name: AddOpen() -------------------------------------------------------------------------------+
// I[vXgɃm[h
// XRAŃ\[găf[^Ǘ
// XRAvZɌĂяoȂ΃f[^\[głȂ
//------------------------------------------------------------------------------------------------+
void Network::Data::AddOpen( int no ){

	lst[no].open = true;
	for( list<int>::iterator p = sorted_open.begin(); p != sorted_open.end(); p++ ){

		if( lst[no].cost + lst[no].heur / HEUR_DIV < lst[*p].cost + lst[*p].heur / HEUR_DIV ){
			sorted_open.insert( p, no );
			return;
		}
	}
	sorted_open.push_back( no );
}
